/* Character conversion from Emacs "Mule" internal coding to UTF-8 / Unicode.
   Copyright (C) 1989, 1993, 2005 Free Software Foundation, Inc.

This file is part of GNU Emacs.

GNU Emacs is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU Emacs is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Emacs; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

Original author: Otfreid Cheong (Copyright (c) 1999, 2000)
Adapted by Adrian Robert (arobert@cogsci.ucsd.edu), 2005

*/

typedef unsigned short UCS2; /* at least 16 bit */
typedef unsigned long  UCS4; /* at least 32 bit */

/* Convert 19-bit mule string to UTF-8 string in buf. */
void muleToUTF8s(const int mule_chs[], int size, unsigned char *outbuf);

/* Convert multibyte mule string to UTF-8 string in buf. */
void mulemToUTF8s(const char *mule_str, int size, char *outbuf);

/* Convert UTF-8 string to multibyte mule string. */
void UTF8sToMulem(const char *utf_str, int size, char *outbuf);
